import java.awt.*;
import java.applet.*;

public class CalendarLayout {
	Container		m_Parent       = null;

	public Datelet button_day[] = new Datelet[42];
	public Datelet button_prevmonth;
	public Datelet button_nextmonth;
	public Datelet label_day[] = new Datelet[7];
	public Datelet label_month;
	public Datelet label_year;
	public String	DayNames[] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday",
							"Friday", "Saturday"};


	// Constructor
	//--------------------------------------------------------------------------
	public CalendarLayout (Container parent) {
		m_Parent = parent;
	}

	// Initialization.
	//--------------------------------------------------------------------------
	public boolean CreateControls()	{
		// m_Parent must be extended from the Container class
		//----------------------------------------------------------------------
		if (!(m_Parent instanceof Container))
			return false;

     // Make a layout manager.
     GridBagLayout layout = new GridBagLayout();
     m_Parent.setLayout( layout );

     // Make the components.
     
     // Make the day buttons
		int dloop = 0;
		for (int vloop=2; vloop<8; vloop++) {
			for (int hloop=0; hloop<7; hloop++) {
          button_day[dloop] = new Datelet( " ", Color.lightGray, Color.black  );
          layout.setConstraints( button_day[dloop], makeGridCons( hloop, vloop, 1, 1, 100, 100, 1 ) );
          m_Parent.add( button_day[dloop] );
          dloop++;
       }
     }
        
     // Make the day Labels
		for (int loop=0; loop<7; loop++) {
        label_day[loop] = new Datelet( DayNames[loop].substring(0,2), Color.green, Color.black );
        layout.setConstraints( label_day[loop], makeGridCons( loop, 1, 1, 1, 100, 100, 1 ) );
        m_Parent.add( label_day[loop] );
     }
       
     // Make the controls
     button_prevmonth = new Datelet( "<<", Color.red, Color.white );
     button_prevmonth.setFont(new Font("Helvetica", Font.BOLD, 18));
     layout.setConstraints( button_prevmonth, makeGridCons( 0, 0, 1, 1, 100, 100, 1 ) );
     m_Parent.add( button_prevmonth );
     button_nextmonth = new Datelet( ">>", Color.red, Color.white  );
     button_nextmonth.setFont(new Font("Helvetica", Font.BOLD, 18));
     layout.setConstraints( button_nextmonth, makeGridCons( 6, 0, 1, 1, 100, 100, 1 ) );
     m_Parent.add( button_nextmonth );
     label_month = new Datelet( "label_month", Color.blue, Color.white );
     layout.setConstraints( label_month, makeGridCons( 1, 0, 3, 1, 100, 100, 1 ) );
     m_Parent.add( label_month );
     label_year = new Datelet( "label_year", Color.blue, Color.white);
     layout.setConstraints( label_year, makeGridCons( 4, 0, 2, 1, 100, 100, 1 ) );
     m_Parent.add( label_year );
     
		return true;
 	}
    
	// --------------------------------------------
	// Define a 'make grid bag constraints' method.
	// --------------------------------------------
  public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, int wx, int wy, int fill )  {

        // Define local variables.
        GridBagConstraints cons = new GridBagConstraints();

        // Set the constraints.
        cons.weightx    = wx;
        cons.weighty    = wy;
        cons.gridx      = x;
        cons.gridy      = y;
        cons.gridwidth  = dx;
        cons.gridheight = dy;
        cons.fill       = fill;

        // Return the constraints to the caller.
        return cons;

    }
 }